
#ifndef bitmap_h
#define bitmap_h

typedef struct {
  u32 Width,Height;
  u16 *pBM;
  bool TransFlag;
} TBitmap;

extern TBitmap* Bitmap_LoadFromFile(char *fn,bool TransFlag);
extern void Bitmap_Free(TBitmap *pbm);
extern void Bitmap_Draw(TBitmap *pbm,CglCanvas *pCanvas,u32 dx,u32 dy);
extern void Bitmap_Draw2(TBitmap *pbm,u32 sx,u32 sy,CglCanvas *pCanvas,u32 dx,u32 dy,u32 dw,u32 dh);

#endif

