
#ifndef savename_h
#define savename_h

// Base code writed by SaTa.

#include "unicode.h"

typedef struct {
  u32 ReleaseNumber;
  char ID[5];
  char *ENGName;
  UnicodeChar *JPNName;
  u32 Offset;
  u8 *Data;
  u32 DataSize;
} TGameData;

void LoadGameDatas(char *UTF8Text,int size);
void CreateGameDatasFind(void);

TGameData *GetGameDataFromSaveData(char *SaveData,int SaveDataSize);

u32 GetDetectSaveSize(void);

#endif //  savename_h
