
#ifndef window_h
#define window_h

typedef struct {
  s32 x,y,w,h;
} TRect;

extern void win_LoadBitmap(void);
extern void win_Init(void);

extern void win_Free(void);

extern void win_SetCallback_ProcVsync(void *pcb);
extern void win_SetCallback_ProcKey(void *pcb);

extern void win_SetTitleMsg(const u16 col,const char *msge,const char *msgj);
extern void win_SetMsgPadX(const u32 x);
extern void win_SetMsgPadY(const u32 y);
extern void win_SetMsgHeight(const u32 h);
extern void win_SetMsg(const u32 idx,const char *msge,const char *msgj);
extern void win_SetMsgColor(const u32 idx,const u16 col);
extern void win_SetRect(TRect r);
extern void win_SetRectNum(u32 x,u32 y,u32 w,u32 h);
extern TRect win_GetRect(void);

extern u16* win_GetClientBuf(void);

extern void win_DrawClientBG(TRect r);
extern void win_DrawMsg(const u32 idx);
extern void win_DrawWindow(void);

extern void win_ShowWindow(void);
extern void win_HideWindow(void);
extern void win_FadeInWindow(void);
extern void win_FadeOutWindow(void);

extern void win_ProcModal(void);

#endif

