
#ifndef inifile_h
#define inifile_h

typedef struct {
  bool EnableFadeWindow;
  bool EnableSE;
  bool SplashScreen;
} TiniSystem;

typedef struct {
  u32 DelayCount;
  u32 RateCount;
} TiniKeyRepeat;

typedef struct {
  bool AddGameID,AddENGName;
  bool AddDateYear,AddDateMonth,AddDateDay;
  bool AddTimeHour,AddTimeMin,AddTimeSec;
  u32 ENGNameLimit;
} TiniNewFilename;

typedef struct {
  TiniSystem System;
  TiniKeyRepeat KeyRepeat;
  TiniNewFilename NewFilename;
} TGlobalINI;

extern TGlobalINI GlobalINI;

extern void InitINI(void);
extern void LoadINI(char *pbuf,u32 size);

#endif

