
void Dialog_OnlineHelp(void)
{
  win_Init();
  
  win_HideWindow();
  
  win_SetTitleMsg(RGB15(0,0,0),"online help","ICwv");
  
  const char *e0="ReinMoon is a tool that manages";
  const char *e1="the save data of the DS card.";
  const char *e2="";
  const char *e3="Press A button.";
  const char *e4="Selected file is read or write.";
  const char *e5="Press START + SELECT button.";
  const char *e6="Saved to a new file.";
  
  const char *j0="ReinMoońADSJ[h̃Z[uf[^";
  const char *j1="Ǘc[łB";
  const char *j2="";
  const char *j3="A{^";
  const char *j4="Iꂽt@Cǂݏ܂B";
  const char *j5="START+SELECT{^";
  const char *j6="VKt@Cɏo܂B";
  
  win_SetMsg(0,e0,j0);
  win_SetMsg(1,e1,j1);
  win_SetMsg(2,e2,j2);
  win_SetMsg(3,e3,j3);
  win_SetMsg(4,e4,j4);
  win_SetMsg(5,e5,j5);
  win_SetMsg(6,e6,j6);
  
  win_SetRectNum(0,0,0,0);
  
  win_DrawWindow();
  Sound_Start(ESND_WinOpen);
  win_FadeInWindow();
  
  WaitKeyClear();
  WaitKeyPress();
  
  Sound_Start(ESND_WinClose);
  win_FadeOutWindow();
  win_Free();
}

static bool DialogResult;

static bool Dialog_StartDialog_ProcKey(u16 loadkeys)
{
  if(loadkeys!=0){
    if(loadkeys==KEY_START){
      DialogResult=true;
      }else{
      DialogResult=false;
    }
    return(false);
  }
  
  return(true);
}

bool Dialog_StartDialog(const char *msge,const char *msgj)
{
  win_Init();
  
  win_HideWindow();
  
  win_SetTitleMsg(RGB15(0,0,0),msge,msgj);
  
  const char *e0="      May I initiate the processing?";
  const char *e1="      START button : START";
  
  const char *j0="      Jn܂H";
  const char *j1="      START{^ : Jn";
  
  win_SetMsgHeight(16);
  
  win_SetMsg(0,e0,j0);
  win_SetMsg(1,e1,j1);
  
  win_SetRectNum(0,0,0,0);
  
  win_SetCallback_ProcKey((void*)Dialog_StartDialog_ProcKey);
  
  win_DrawWindow();
  
  {
    CglCanvas *pCanvas=pScreenMainOverlay->pCanvas;
    TRect r=win_GetRect();
    Bitmap_Draw(pIconWarning,pCanvas,r.x,r.y);
  }
  
  Sound_Start(ESND_Process);
  win_FadeInWindow();
  
  WaitKeyClear();
  
  win_ProcModal();
  
  if(DialogResult==false) Sound_Start(ESND_WinClose);
  
  win_FadeOutWindow();
  win_Free();
  
  return(DialogResult);
}

void Dialog_ErrorDialog(const char *msge,const char *msgj)
{
  win_Init();
  
  win_HideWindow();
  
  win_SetTitleMsg(RGB15(0,0,0),msge,msgj);
  
  const char *e0="      The error occurred.";
  const char *e1="      stopped.";
  
  const char *j0="      G[܂B";
  const char *j1="      f܂B";
  
  win_SetMsgHeight(16);
  
  win_SetMsg(0,e0,j0);
  win_SetMsg(1,e1,j1);
  
  win_SetRectNum(0,0,0,0);
  
  win_DrawWindow();
  
  {
    CglCanvas *pCanvas=pScreenMainOverlay->pCanvas;
    TRect r=win_GetRect();
    Bitmap_Draw(pIconWarning,pCanvas,r.x,r.y);
  }
  
  Sound_Start(ESND_Error);
  win_FadeInWindow();
  
  WaitKeyClear();
  WaitKeyPress();
  
  Sound_Start(ESND_WinClose);
  
  win_FadeOutWindow();
  win_Free();
}

void Dialog_CompliteDialog(const char *msge,const char *msgj)
{
  win_Init();
  
  win_HideWindow();
  
  win_SetTitleMsg(RGB15(0,0,0),"complite","");
  
  win_SetMsgHeight(16);
  
  win_SetMsg(0,msge,msgj);
  win_SetMsg(1,"Press any key.","L[ĂB");
  
  win_SetRectNum(0,0,0,0);
  
  win_DrawWindow();
  
  Sound_Start(ESND_Complite);
  win_FadeInWindow();
  
  WaitKeyClear();
  WaitKeyPress();
  
  Sound_Start(ESND_WinClose);
  
  win_FadeOutWindow();
  win_Free();
}

void ProgressWindow_Open(const char *msge,const char *msgj)
{
  win_Init();
  
  win_HideWindow();
  
  win_SetTitleMsg(RGB15(0,0,0),"processing...","c");
  
  win_SetMsg(0,msge,msgj);
  
  win_SetRectNum(0,0,pPrgPosi->Width,16+pPrgPosi->Height);
  
  win_DrawWindow();
  
  win_ShowWindow();
}

void ProgressWindow_SetPos(u32 pos,u32 max)
{
  TBitmap *pposi=pPrgPosi;
  TBitmap *pnega=pPrgNega;
  
  u32 PrgWidth=pposi->Width;
  u32 PrgHeight=pposi->Height;
  
  TRect r=win_GetRect();
  
  CglCanvas *pCanvas=pScreenMainOverlay->pCanvas;
  
  u32 x=((PrgWidth-16)*pos)/max;
  x+=8;
  
  if(0<x){
    Bitmap_Draw2(pposi,0,0,pCanvas,r.x,r.y+16,x,PrgHeight);
  }
  if(x<PrgWidth){
    Bitmap_Draw2(pnega,x,0,pCanvas,r.x+x,r.y+16,PrgWidth-x,PrgHeight);
  }
  
}

void ProgressWindow_Close(void)
{
  win_HideWindow();
  win_Free();
}


